from Sprite import *
import config
import random
import Area

class Clouds:

	def __init__(self, name = "cloud", subname = "cloud"):
		self.name = name
		self.subname = subname
		self.clouds = []
		self.speeds = [60, 15]
		self.mu = 5000
		self.sigma = 1500
		self.nextCloud = random.gauss(self.mu, self.sigma)
		
		def dummy(x): pass
		
		self.missile_hit = [dummy]*4
		self.enter_area = [dummy]*4
			
	def setMissileHits(self, mhits):
		self.missile_hit = mhits
	
	def setSpeeds(self, spds):
		self.speeds = spds
	
	def setGauss(self, mu, sigma):
		self.mu = mu
		self.sigma = sigma
		
	
	def update(self, dt):
	
		# Check if a random cloud should be added
		self.nextCloud -= dt
		if self.nextCloud <= 0:
			self.nextCloud = random.gauss(self.mu, self.sigma)
			
			# Which sprite
			ctype = random.randint(0,3)
			c = MovingSprite(self.name, self.subname + str(ctype))
			
			### hack for bonus
			c.hp = 10	
			c.missile_hit = self.missile_hit[ctype]
			c.enter_area = self.enter_area[ctype]
			c.kind = "very kind"
			
			self.clouds.append( c )
						
			# determine location and speed
			x = random.randint(0, config.SCREEN_WIDTH)
			y = -50
			
			cspd = self.speeds[int(ctype / 2)]
			spd = max(10, random.gauss(cspd, cspd/4.0))
			
			c.move(x, y)
			c.set_destination(x, 100, spd)
			
			c.show()
			c.start()
	
		for c in self.clouds:
			if c.y < config.SCREEN_HEIGHT:
				# safe to prepare for removal
				c.out_of_screen_callback(self.clouds.remove, c)
			c.update(dt)
	
	def draw(self, display):
		for c in self.clouds:
			c.draw(display)

class Bonuses(Clouds):
	
	def __init__(self, bonusState):
		Clouds.__init__(self, "smballoon", "smballoon")
		self.bonusState = bonusState
		
		def bonus1_missile_hit(missile):
			self.bonusState["multishot"] = 10000
			self.clouds[0].stop()
			self.clouds[0].show(False)
			self.clouds = []
			return

		def bonus1_enter_area(area):
			if isinstance(area, Area.Thunder):
				self.bonusState["multishot"] = 10000
				self.clouds[0].stop()
				self.clouds[0].show(False)
				self.clouds = []
		
		self.missile_hit[0] = bonus1_missile_hit
		self.missile_hit[1] = bonus1_missile_hit
		self.missile_hit[2] = bonus1_missile_hit
		self.missile_hit[3] = bonus1_missile_hit
		
		self.enter_area[0] = bonus1_enter_area
		self.enter_area[1] = bonus1_enter_area
		self.enter_area[2] = bonus1_enter_area
		self.enter_area[3] = bonus1_enter_area
	
	def update(self, dt):
		Clouds.update(self, dt)
		# There can be only one!!
		if len(self.clouds):
			self.clouds = [self.clouds[0]]
